--- dcraw.h.orig	2016-07-30 16:21:06 UTC
+++ dcraw.h
@@ -54,10 +54,12 @@ public:
     unsigned thumb_misc, *oprof, fuji_layout, shot_select, multi_out;
     unsigned tiff_nifds, tiff_samples, tiff_bps, tiff_compress;
     unsigned black, maximum, mix_green, raw_color, zero_is_bad;
+    unsigned max4[4];
     unsigned zero_after_ff, is_raw, dng_version, is_foveon, data_error;
     unsigned tile_width, tile_length, gpsdata[32], load_flags;
     unsigned flip, tiff_flip, filters, colors;
-    ushort raw_height, raw_width, height, width, top_margin, left_margin;
+    ushort raw_height, raw_width, height, width, top_margin;
+    short left_margin;
     ushort shrink, iheight, iwidth, fuji_width, thumb_width, thumb_height;
     ushort *raw_image, (*image)[4], cblack[4102];
     ushort white[8][8], curve[0x10000], cr2_slice[3], sraw_mul[4];
@@ -284,6 +286,8 @@ public:
     void simple_coeff(int index);
     short guess_byte_order(int words);
     float find_green(int bps, int bite, int off0, int off1);
+    void read_env();
+    void apply_black_sat(int const user_black, int const user_sat[]);
     void identify();
 #ifndef NO_LCMS
     void apply_profile(const char *input, const char *output);
